## Todo

### Compiler

- [x] Tokenizer
- [x] Scanner
- [x] Functions
- [x] Variables
- [x] Error messages
- [x] Expression parser
- [x] Function calls
- [x] Parallel compilation
- [x] Syscalls
- [x] Variable lifetimes
- [x] Branches
- [x] Loops
- [x] Hexadecimal, octal and binary literals
- [x] Escape sequences
- [x] Multiple return values
- [x] Data structures
- [x] Type system
- [ ] Dynamic libraries: Linux Mac ~~Windows~~
- [ ] Unsigned types
- [ ] Type operator `?`
- [ ] Slices
- [ ] Floating-point arithmetic
- [ ] Self-hosted compiler

### Library

- [ ] Efficient memory allocator
- [ ] Error handling
- [ ] Multithreading: ~~Linux~~ Mac ~~Windows~~

### Keywords

- [x] `assert`
- [x] `const`
- [x] `else`
- [x] `extern`
- [x] `for`
- [x] `if`
- [x] `import`
- [x] `loop`
- [x] `return`
- [x] `switch`

### Optimizations

- [x] Exclude unused functions
- [x] Constant folding
- [ ] Constant propagation
- [ ] Function call inlining
- [ ] Loop unrolls
- [ ] Assembler optimization backend

### Linter

- [x] Unused variables
- [x] Unused parameters
- [x] Unused imports
- [ ] Unnecessary newlines
- [ ] Ineffective assignments

### Operators

- [x] `=`, `:=`
- [x] `+`, `-`, `*`, `/`, `%`
- [x] `+=`, `-=`, `*=`, `/=`, `%=`
- [x] `&`, `|`, `^`
- [x] `&=`, `|=`, `^=`
- [x] `<<`, `>>`
- [x] `<<=`, `>>=`
- [x] `==`, `!=`, `<`, `<=`, `>`, `>=`
- [x] `&&`, `||`
- [ ] `!`, `-`

### Architecture

- [ ] arm
- [ ] riscv
- [x] x86

### Platform

- [x] Linux
- [x] Mac
- [x] Windows